#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXWIDTH	640
#define	MAXHEIGHT	204

void	convpic(int,int,unsigned char c_pixel[MAXWIDTH/2][MAXHEIGHT],unsigned char pixel[MAXWIDTH][MAXHEIGHT]);
void	convpic2(int,int,unsigned char c_pixel[MAXWIDTH/2][MAXHEIGHT],unsigned char pixel[MAXWIDTH][MAXHEIGHT]);
void	convpic3(int,int,unsigned char c_pixel[MAXWIDTH/2][MAXHEIGHT],unsigned char pixel[MAXWIDTH][MAXHEIGHT]);
int		read_data1(FILE *);
int		read_data2(FILE *);

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	unsigned char	pixel[MAXWIDTH][MAXHEIGHT];
	unsigned char	c_pixel[MAXWIDTH/2][MAXHEIGHT];

	int		width,height;
	int		x,y,col;
	int		c,i;
	int		sft;
	int		a0,a1,a2,a3;
	int		d0,d1;
	int		flen;
	int		stadd;
	int		convpat;

	if (argc != 5) {
		fprintf(stderr, "Usage: convpict infile outfile stadd convpat\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	stadd   = atoi(argv[3]);
	convpat = atoi(argv[4]);

	fseek(infp,(long)stadd,SEEK_SET);


	width = fgetc(infp) * 8;
	height = fgetc(infp);

	if ( (width > MAXWIDTH) || (height > MAXHEIGHT) ) {
		fprintf(stderr,"Size is too large\n");
		exit(1);
	}

	for (y = 0;y < MAXHEIGHT;y ++) {
		for (x = 0;x < MAXWIDTH;x ++) {
			pixel[x][y] = 0x08;
		}
	}

	for (y = 0;y < MAXHEIGHT;y ++) {
		for (x = 0;x < MAXWIDTH/2;x ++) {
			c_pixel[x][y] = 0x08;
		}
	}


	for (y = 0;y < height;y ++) {
		for (col = 0x01;col < 0x08;col *= 2) {
			for (x = 0;x < width;x += 8) {
				c = read_data2(infp);
				sft = 0x80;
				for (i = 0;i < 8;i ++) {
					if (y < 2) {
						if ( (c & sft) != 0) {
							pixel[x+i][y] |= col;
						}
					} else {
						if ( (c & sft) != 0) {
							if ( (pixel[x+i][y-2] & col) == 0x00) {
								pixel[x+i][y] |= col;
							}
						} else {
							if ( (pixel[x+i][y-2] & col) != 0x00) {
								pixel[x+i][y] |= col;
							}
						}
					}
					sft /= 2;
				}
			}
		}

	}

/* hbgԈ */
	if (convpat == 1 || convpat == 2) {
		convpic2(width,height,c_pixel,pixel);
	} else if (convpat == 3) {
		convpic3(width,height,c_pixel,pixel);
	} else {
		convpic(width,height,c_pixel,pixel);
	}

/* ʑΉ */
	if (convpat == 1) {

		for (y = 0;y < height;y ++) {
			for (x = 0;x < width/2;x ++) {
				switch (c_pixel[x][y]) {
					case 0x0e: c_pixel[x][y] = 0x09; break; /*  */
					case 0x0d: c_pixel[x][y] = 0x0f; break; /* (7) */
					case 0x0c: c_pixel[x][y] = 0x0e; break; /* ΁(6) */
					case 0x0b: c_pixel[x][y] = 0x0e; break; /* (6) */
					case 0x0a: c_pixel[x][y] = 0x0d; break; /* ԁ(5) */
					case 0x09: c_pixel[x][y] = 0x0c; break; /* (4) */
					default: break;
				}
			}
		}

	} else if (convpat == 2) {

		for (y = 0;y < height;y ++) {
			for (x = 0;x < width/2;x ++) {
				switch (c_pixel[x][y]) {
					case 0x0e: c_pixel[x][y] = 0x0e; break; /*  */
					case 0x0d: c_pixel[x][y] = 0x0e; break; /*  */
					case 0x0c: c_pixel[x][y] = 0x0e; break; /* ΁ */
					case 0x0b: c_pixel[x][y] = 0x0e; break; /*  */
					case 0x0a: c_pixel[x][y] = 0x0e; break; /* ԁ */
					case 0x09: c_pixel[x][y] = 0x0e; break; /*  */
					default: break;
				}
			}
		}

	} else if (convpat == 4) {

		for (y = 0;y < height;y ++) {
			for (x = 0;x < width/2;x ++) {
				switch (c_pixel[x][y]) {
					case 0x0d: c_pixel[x][y] = 0x08; break; /*  */
					case 0x08: c_pixel[x][y] = 0x0d; break; /*  */
					default: break;
				}
			}
		}

	} else if (convpat == 5) {

		for (y = 0;y < height;y ++) {
			for (x = 0;x < width/2;x ++) {
				switch (c_pixel[x][y]) {
					case 0x0f: c_pixel[x][y] = 0x0f; break; /*  */
					case 0x0e: c_pixel[x][y] = 0x0e; break; /*  */
					case 0x0d: c_pixel[x][y] = 0x0c; break; /* () */
					case 0x0c: c_pixel[x][y] = 0x0c; break; /* ΁() */
					case 0x0b: c_pixel[x][y] = 0x0c; break; /* () */
					case 0x0a: c_pixel[x][y] = 0x0c; break; /* ԁ() */
					case 0x09: c_pixel[x][y] = 0x0c; break; /* () */
					case 0x08: c_pixel[x][y] = 0x0d; break; /*  */
					default: break;
				}
			}
		}

	} else if (convpat == 6) {

		for (y = 0;y < height;y ++) {
			for (x = 0;x < width/2;x ++) {
				switch (c_pixel[x][y]) {
					case 0x0b: c_pixel[x][y] = 0x08; break; /*  */
					default: break;
				}
			}
		}

	} else if (convpat == 7) {

		for (y = 0;y < height;y ++) {
			for (x = 0;x < width/2;x ++) {
				switch (c_pixel[x][y]) {
					case 0x0f: c_pixel[x][y] = 0x0f; break; /*  */
					case 0x0e: c_pixel[x][y] = 0x0f; break; /*  */
					case 0x0d: c_pixel[x][y] = 0x0f; break; /*  */
					case 0x0c: c_pixel[x][y] = 0x0f; break; /* ΁ */
					case 0x0b: c_pixel[x][y] = 0x08; break; /*  */
					case 0x0a: c_pixel[x][y] = 0x08; break; /* ԁ */
					case 0x09: c_pixel[x][y] = 0x08; break; /*  */
					case 0x08: c_pixel[x][y] = 0x08; break; /*  */
					default: break;
				}
			}
		}

	}



/* f[^o */
/*
ʃf[^iX-Yj
0-0, 1-0, 2-0, 3-0, 4-0, 5-0, 6-0, 7-0, ...
0-1, 1-1, 2-1, 3-1, 4-1, 5-1, 6-1, 7-1, ...
0-2, 1-2, 2-2, 3-2, 4-2, 5-2, 6-2, 7-2, ...

f[^iVRAMj
1-0&0-0, 3-0&2-0, 5-0&4-0, 7-0&6-0, ...
1-1&0-1, 3-1&2-1, 5-1&4-1, 7-1&6-1, ...
1-2&0-2, 3-2&2-2, 5-2&4-2, 7-2&6-2, ...

*/

	fputc(width/8,outfp);
	fputc(height,outfp);

	for (y = 0;y < height;y ++) {
		for (x = 0;x < width/2;x += 4) {

			a0 = c_pixel[x+0][y+0];
			a1 = c_pixel[x+1][y+0] << 4;
			fputc(a0|a1,outfp);
			a0 = c_pixel[x+2][y+0];
			a1 = c_pixel[x+3][y+0] << 4;
			fputc(a0|a1,outfp);

		}

	}


	flen = ftell(infp);
	printf("88:%d ",flen-stadd);


	fclose(outfp);
	fclose(infp);

	return(0);
}

int		read_data2(FILE *fp)
{
	static int	rdata = 0x00;
	static int	sft = 0x80;

	int		ret;

	if (sft == 0x80) {
		rdata = read_data1(fp);
	}

	if ( (rdata & sft) != 0x00) {
		ret = fgetc(fp);
	} else {
		ret = 0x00;
	}

	if (sft == 0x01) {
		sft = 0x80;
	} else {
		sft /= 2;
	}

	return ret;
}


int		read_data1(FILE *fp)
{
	static int	rptr = 8;
	static int	rdata[8];
	int		sft,i;
	int		c,ret;


	if (rptr == 8) {
		rptr = 0;

		sft = 0x80;
		c = fgetc(fp);
		for (i = 0;i < 8;i ++) {
			if ( (c & sft) != 0x00) {
				rdata[i] = fgetc(fp);
			} else {
				rdata[i] = 0x00;
			}
			sft /= 2;
		}
	}

	ret=rdata[rptr];
	rptr ++;

	return ret;
}


void	convpic3(int picsize_x,int picsize_y,unsigned char c_pixel[MAXWIDTH/2][MAXHEIGHT],unsigned char pixel[MAXWIDTH][MAXHEIGHT])
{
	int		x,y;

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}
	}

	return;
}

void	convpic2(int picsize_x,int picsize_y,unsigned char c_pixel[MAXWIDTH/2][MAXHEIGHT],unsigned char pixel[MAXWIDTH][MAXHEIGHT])
{
	int		x,y;

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			if (pixel[x*2+0][y] != 0x08) {
				c_pixel[x+0][y] = pixel[x*2+0][y];
			} else {
				c_pixel[x+0][y] = pixel[x*2+1][y];
			}
		}
	}

	return;
}

void	convpic(int picsize_x,int picsize_y,unsigned char c_pixel[MAXWIDTH/2][MAXHEIGHT],unsigned char pixel[MAXWIDTH][MAXHEIGHT])
{

	int		x,y;

	for (y = 0;y < picsize_y;y ++) {
		for (x = 0;x < picsize_x/2;x ++) {
			c_pixel[x+0][y] = pixel[x*2+0][y];
		}

		for (x = 0;x < picsize_x/2 - 1;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+2][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+3][y])
			) {
				if ( (x%2) == 0) {
					c_pixel[x+0][y] = pixel[x*2+0][y];
					c_pixel[x+1][y] = pixel[x*2+3][y];
				} else {
					c_pixel[x+0][y] = pixel[x*2+1][y];
					c_pixel[x+1][y] = pixel[x*2+2][y];
				}
			}
		}

		for (x = 0;x < picsize_x/2 - 3;x ++) {
			if (
				(pixel[x*2+0][y] == pixel[x*2+4][y]) && 
				(pixel[x*2+1][y] == pixel[x*2+5][y]) &&
				(pixel[x*2+2][y] == pixel[x*2+6][y]) && 
				(pixel[x*2+3][y] == pixel[x*2+7][y])
			) {

				if (pixel[x*2+0][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}

				} else if (pixel[x*2+0][y] == pixel[x*2+1][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+1][y] == pixel[x*2+2][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+2][y] == pixel[x*2+3][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				} else if (pixel[x*2+3][y] == pixel[x*2+0][y]) {
					if ( (x%4) == 0) {
						c_pixel[x+0][y] = pixel[x*2+0][y];
						c_pixel[x+1][y] = pixel[x*2+1][y];
						c_pixel[x+2][y] = pixel[x*2+6][y];
						c_pixel[x+3][y] = pixel[x*2+7][y];
					} else if ( (x%4) == 1) {
						c_pixel[x+0][y] = pixel[x*2+7][y];
						c_pixel[x+1][y] = pixel[x*2+4][y];
						c_pixel[x+2][y] = pixel[x*2+5][y];
						c_pixel[x+3][y] = pixel[x*2+6][y];
					} else if ( (x%4) == 2) {
						c_pixel[x+0][y] = pixel[x*2+2][y];
						c_pixel[x+1][y] = pixel[x*2+3][y];
						c_pixel[x+2][y] = pixel[x*2+4][y];
						c_pixel[x+3][y] = pixel[x*2+5][y];
					} else {
						c_pixel[x+0][y] = pixel[x*2+1][y];
						c_pixel[x+1][y] = pixel[x*2+2][y];
						c_pixel[x+2][y] = pixel[x*2+3][y];
						c_pixel[x+3][y] = pixel[x*2+0][y];
					}
				}
			}
		}
	}

	return;
}

